use Test2::V0;

my $arr  = [qw/a b c d e/];
my $hash = { foo => 1, bar => 2, baz => 3 };


subtest '従来の書き方' => sub {
    my @all         = @$arr;
    my ($b, $c, $d) = @$arr[1..3];
    my %copy        = %$hash;
    my %part        = %$hash{qw/foo/}; # ( foo => 1 )
    my ($bar, $baz) = @$hash{qw/bar baz/};

    is \@all, $arr;
    is $b, 'b';
    is $c, 'c';
    is $d, 'd';
    is \%copy, $hash;
    is \%part, { foo => 1 };
    is $bar, 2;
    is $baz, 3;
};

subtest 'postderefを利用' => sub {
    my @all         = $arr->@*;
    my ($b, $c, $d) = $arr->@[1..3];
    my %copy        = $hash->%*;
    my %part        = $hash->%{qw/foo/}; # ( foo => 1 )
    my ($bar, $baz) = $hash->@{qw/bar baz/};

    is \@all, $arr;
    is $b, 'b';
    is $c, 'c';
    is $d, 'd';
    is \%copy, $hash;
    is \%part, { foo => 1 };
    is $bar, 2;
    is $baz, 3;
};

done_testing;
